(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@angular-material-extensions/pages', ['exports', '@angular/core', '@angular/material', '@angular/common'], factory) :
    (global = global || self, factory((global['angular-material-extensions'] = global['angular-material-extensions'] || {}, global['angular-material-extensions'].pages = {}), global.ng.core, global.ng.material, global.ng.common));
}(this, function (exports, core, material, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatPageContentComponent = /** @class */ (function () {
        function MatPageContentComponent() {
        }
        /**
         * @return {?}
         */
        MatPageContentComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        MatPageContentComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mat-page-content',
                        template: "<ng-template>\n  <mat-card style=\"margin: 2rem\">\n    <mat-card-title>{{title}}</mat-card-title>\n    <mat-card-content>\n      <ng-content></ng-content>\n    </mat-card-content>\n  </mat-card>\n</ng-template>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        MatPageContentComponent.ctorParameters = function () { return []; };
        MatPageContentComponent.propDecorators = {
            content: [{ type: core.ViewChild, args: [core.TemplateRef, { static: false },] }],
            title: [{ type: core.Input }]
        };
        return MatPageContentComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatPageOutlookComponent = /** @class */ (function () {
        function MatPageOutlookComponent() {
        }
        /**
         * @return {?}
         */
        MatPageOutlookComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        MatPageOutlookComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mat-page-outlook',
                        template: "<ng-template>\n  <ng-content></ng-content>\n</ng-template>\n",
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        MatPageOutlookComponent.ctorParameters = function () { return []; };
        MatPageOutlookComponent.propDecorators = {
            content: [{ type: core.ViewChild, args: [core.TemplateRef, { static: false },] }],
            title: [{ type: core.Input }]
        };
        return MatPageOutlookComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatPageLoaderComponent = /** @class */ (function () {
        function MatPageLoaderComponent() {
        }
        MatPageLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mat-page-loader',
                        template: "",
                        styles: [""]
                    }] }
        ];
        MatPageLoaderComponent.propDecorators = {
            pageOutlook: [{ type: core.ContentChild, args: [MatPageOutlookComponent, { static: false },] }],
            pageContent: [{ type: core.ContentChild, args: [MatPageContentComponent, { static: false },] }]
        };
        return MatPageLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatPagesComponent = /** @class */ (function () {
        function MatPagesComponent(renderer) {
            this.renderer = renderer;
            this.done = new core.EventEmitter();
            this.pageChanged = new core.EventEmitter();
            // the mode of the sidenav
            this.navMode = 'side';
            this.index = 0;
        }
        /**
         * @private
         * @return {?}
         */
        MatPagesComponent.prototype._initSidenavMode = /**
         * @private
         * @return {?}
         */
        function () {
            if (window.innerWidth < 768) {
                this.navMode = 'over';
            }
        };
        /**
         * @return {?}
         */
        MatPagesComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this._initSidenavMode();
        };
        /**
         * @return {?}
         */
        MatPagesComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
        function () {
            this.totalPages = this.pages.length;
            this.renderer.setStyle(this.tabHeader.nativeElement.children[0], 'display', 'none');
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatPagesComponent.prototype.onResize = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.target.innerWidth < 768) {
                this.navMode = 'over';
                this.sidenav.close();
            }
            if (event.target.innerWidth > 768) {
                this.navMode = 'side';
                this.sidenav.open();
            }
        };
        /**
         * Go to the previous page if it exists
         */
        /**
         * Go to the previous page if it exists
         * @return {?}
         */
        MatPagesComponent.prototype.previous = /**
         * Go to the previous page if it exists
         * @return {?}
         */
        function () {
            this.index = this.index === 0 ? 0 : --this.index;
            this.pageChanged.emit(this.index);
        };
        /**
         * Go to the next page if it exists
         */
        /**
         * Go to the next page if it exists
         * @return {?}
         */
        MatPagesComponent.prototype.next = /**
         * Go to the next page if it exists
         * @return {?}
         */
        function () {
            this.index = this.index === this.totalPages - 1 ? this.totalPages - 1 : ++this.index;
            this.pageChanged.emit(this.index);
            if (this.index === this.totalPages - 1) {
                this.done.emit();
            }
        };
        /**
         * Update the value of the index when a step has been selected.
         * Emit this value for pagechanged's subscribers.
         *
         */
        /**
         * Update the value of the index when a step has been selected.
         * Emit this value for pagechanged's subscribers.
         *
         * @param {?} event
         * @return {?}
         */
        MatPagesComponent.prototype.onStepSelectionChange = /**
         * Update the value of the index when a step has been selected.
         * Emit this value for pagechanged's subscribers.
         *
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.index = event.selectedIndex;
            this.pageChanged.emit(this.index);
        };
        MatPagesComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mat-pages',
                        template: "<mat-sidenav-container>\n  <mat-sidenav #sidenav [mode]=\"navMode\" opened=\"true\"\n               [fixedInViewport]=\"'false'\" [fixedTopGap]=\"'false'\" [fixedBottomGap]=\"'false'\">\n\n    <mat-toolbar color=\"primary\">\n    </mat-toolbar>\n\n    <mat-vertical-stepper [selectedIndex]=\"index\" (selectionChange)=\"onStepSelectionChange($event)\">\n      <mat-step *ngFor=\"let page of pages;let i = index;\" [label]=\"page.pageOutlook.title\">\n        <ng-container [ngTemplateOutlet]=\"page.pageOutlook.content\"></ng-container>\n      </mat-step>\n    </mat-vertical-stepper>\n  </mat-sidenav>\n\n  <mat-sidenav-content>\n    <mat-toolbar color=\"primary\">\n      <button mat-icon-button (click)=\"sidenav.toggle()\">\n        <mat-icon>menu</mat-icon>\n      </button>\n      {{title}}\n    </mat-toolbar>\n    <div class=\"demo-sidenav-content main-container\">\n\n      <mat-tab-group [selectedIndex]=\"index\" style=\"min-height: 15vh;\" >\n        <button mat-fab color=\"warn\" (click)=\"previous()\">\n          <mat-icon>location</mat-icon>\n        </button>\n        <mat-tab *ngFor=\"let page of pages;let i = index;\">\n          <ng-template matTabContent>\n            <ng-container [ngTemplateOutlet]=\"page.pageContent.content\"></ng-container>\n          </ng-template>\n        </mat-tab>\n      </mat-tab-group>\n\n\n      <div class=\"navigation-buttons\">\n        <button mat-fab color=\"primary\" (click)=\"previous()\" [disabled]=\"index == 0\">\n          <mat-icon>chevron_left</mat-icon>\n        </button>\n        <div *ngIf=\"index == totalPages - 1;then finished else nextAvailable\">\n        </div>\n        <ng-template #nextAvailable>\n          <button mat-fab color=\"primary\" (click)=\"next()\">\n            <mat-icon>chevron_right</mat-icon>\n          </button>\n        </ng-template>\n        <ng-template #finished>\n          <button mat-fab color=\"accent\" (click)=\"done.next()\">\n            <mat-icon>done</mat-icon>\n          </button>\n        </ng-template>\n      </div>\n\n    </div>\n  </mat-sidenav-content>\n</mat-sidenav-container>\n",
                        styles: [".navigation-buttons{margin:1rem;place-content:stretch space-between;-webkit-box-align:stretch;align-items:stretch;-webkit-box-orient:horizontal;-webkit-box-direction:normal;flex-direction:row;box-sizing:border-box;display:-webkit-box;display:flex}"]
                    }] }
        ];
        /** @nocollapse */
        MatPagesComponent.ctorParameters = function () { return [
            { type: core.Renderer2 }
        ]; };
        MatPagesComponent.propDecorators = {
            sidenav: [{ type: core.ViewChild, args: ['sidenav', { static: false },] }],
            tabHeader: [{ type: core.ViewChild, args: [material.MatTabGroup, { read: core.ElementRef, static: true },] }],
            pages: [{ type: core.ContentChildren, args: [MatPageLoaderComponent,] }],
            title: [{ type: core.Input }],
            done: [{ type: core.Output }],
            pageChanged: [{ type: core.Output }],
            onResize: [{ type: core.HostListener, args: ['window:resize', ['$event'],] }]
        };
        return MatPagesComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatPagesModule = /** @class */ (function () {
        function MatPagesModule() {
        }
        /**
         * @return {?}
         */
        MatPagesModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: MatPagesModule,
                providers: []
            };
        };
        MatPagesModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            material.MatToolbarModule,
                            material.MatTabsModule,
                            material.MatCardModule,
                            material.MatSidenavModule,
                            material.MatIconModule,
                            material.MatStepperModule,
                            material.MatButtonModule
                        ],
                        exports: [
                            MatPagesComponent,
                            MatPageLoaderComponent,
                            MatPageOutlookComponent,
                            MatPageContentComponent
                        ],
                        declarations: [
                            MatPagesComponent,
                            MatPageLoaderComponent,
                            MatPageOutlookComponent,
                            MatPageContentComponent
                        ]
                    },] }
        ];
        return MatPagesModule;
    }());

    exports.MatPageContentComponent = MatPageContentComponent;
    exports.MatPageLoaderComponent = MatPageLoaderComponent;
    exports.MatPageOutlookComponent = MatPageOutlookComponent;
    exports.MatPagesComponent = MatPagesComponent;
    exports.MatPagesModule = MatPagesModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular-material-extensions-pages.umd.js.map
