import { Component, ViewChild, TemplateRef, Input, ViewEncapsulation, ChangeDetectionStrategy, ContentChild, EventEmitter, Renderer2, ElementRef, ContentChildren, Output, HostListener, NgModule } from '@angular/core';
import { MatTabGroup, MatToolbarModule, MatTabsModule, MatCardModule, MatSidenavModule, MatIconModule, MatStepperModule, MatButtonModule } from '@angular/material';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MatPageContentComponent {
    constructor() {
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
MatPageContentComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-page-content',
                template: "<ng-template>\n  <mat-card style=\"margin: 2rem\">\n    <mat-card-title>{{title}}</mat-card-title>\n    <mat-card-content>\n      <ng-content></ng-content>\n    </mat-card-content>\n  </mat-card>\n</ng-template>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
MatPageContentComponent.ctorParameters = () => [];
MatPageContentComponent.propDecorators = {
    content: [{ type: ViewChild, args: [TemplateRef, { static: false },] }],
    title: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MatPageOutlookComponent {
    constructor() {
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
MatPageOutlookComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-page-outlook',
                template: "<ng-template>\n  <ng-content></ng-content>\n</ng-template>\n",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                styles: [""]
            }] }
];
/** @nocollapse */
MatPageOutlookComponent.ctorParameters = () => [];
MatPageOutlookComponent.propDecorators = {
    content: [{ type: ViewChild, args: [TemplateRef, { static: false },] }],
    title: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MatPageLoaderComponent {
}
MatPageLoaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-page-loader',
                template: "",
                styles: [""]
            }] }
];
MatPageLoaderComponent.propDecorators = {
    pageOutlook: [{ type: ContentChild, args: [MatPageOutlookComponent, { static: false },] }],
    pageContent: [{ type: ContentChild, args: [MatPageContentComponent, { static: false },] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MatPagesComponent {
    /**
     * @param {?} renderer
     */
    constructor(renderer) {
        this.renderer = renderer;
        this.done = new EventEmitter();
        this.pageChanged = new EventEmitter();
        // the mode of the sidenav
        this.navMode = 'side';
        this.index = 0;
    }
    /**
     * @private
     * @return {?}
     */
    _initSidenavMode() {
        if (window.innerWidth < 768) {
            this.navMode = 'over';
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this._initSidenavMode();
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        this.totalPages = this.pages.length;
        this.renderer.setStyle(this.tabHeader.nativeElement.children[0], 'display', 'none');
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onResize(event) {
        if (event.target.innerWidth < 768) {
            this.navMode = 'over';
            this.sidenav.close();
        }
        if (event.target.innerWidth > 768) {
            this.navMode = 'side';
            this.sidenav.open();
        }
    }
    /**
     * Go to the previous page if it exists
     * @return {?}
     */
    previous() {
        this.index = this.index === 0 ? 0 : --this.index;
        this.pageChanged.emit(this.index);
    }
    /**
     * Go to the next page if it exists
     * @return {?}
     */
    next() {
        this.index = this.index === this.totalPages - 1 ? this.totalPages - 1 : ++this.index;
        this.pageChanged.emit(this.index);
        if (this.index === this.totalPages - 1) {
            this.done.emit();
        }
    }
    /**
     * Update the value of the index when a step has been selected.
     * Emit this value for pagechanged's subscribers.
     *
     * @param {?} event
     * @return {?}
     */
    onStepSelectionChange(event) {
        this.index = event.selectedIndex;
        this.pageChanged.emit(this.index);
    }
}
MatPagesComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-pages',
                template: "<mat-sidenav-container>\n  <mat-sidenav #sidenav [mode]=\"navMode\" opened=\"true\"\n               [fixedInViewport]=\"'false'\" [fixedTopGap]=\"'false'\" [fixedBottomGap]=\"'false'\">\n\n    <mat-toolbar color=\"primary\">\n    </mat-toolbar>\n\n    <mat-vertical-stepper [selectedIndex]=\"index\" (selectionChange)=\"onStepSelectionChange($event)\">\n      <mat-step *ngFor=\"let page of pages;let i = index;\" [label]=\"page.pageOutlook.title\">\n        <ng-container [ngTemplateOutlet]=\"page.pageOutlook.content\"></ng-container>\n      </mat-step>\n    </mat-vertical-stepper>\n  </mat-sidenav>\n\n  <mat-sidenav-content>\n    <mat-toolbar color=\"primary\">\n      <button mat-icon-button (click)=\"sidenav.toggle()\">\n        <mat-icon>menu</mat-icon>\n      </button>\n      {{title}}\n    </mat-toolbar>\n    <div class=\"demo-sidenav-content main-container\">\n\n      <mat-tab-group [selectedIndex]=\"index\" style=\"min-height: 15vh;\" >\n        <button mat-fab color=\"warn\" (click)=\"previous()\">\n          <mat-icon>location</mat-icon>\n        </button>\n        <mat-tab *ngFor=\"let page of pages;let i = index;\">\n          <ng-template matTabContent>\n            <ng-container [ngTemplateOutlet]=\"page.pageContent.content\"></ng-container>\n          </ng-template>\n        </mat-tab>\n      </mat-tab-group>\n\n\n      <div class=\"navigation-buttons\">\n        <button mat-fab color=\"primary\" (click)=\"previous()\" [disabled]=\"index == 0\">\n          <mat-icon>chevron_left</mat-icon>\n        </button>\n        <div *ngIf=\"index == totalPages - 1;then finished else nextAvailable\">\n        </div>\n        <ng-template #nextAvailable>\n          <button mat-fab color=\"primary\" (click)=\"next()\">\n            <mat-icon>chevron_right</mat-icon>\n          </button>\n        </ng-template>\n        <ng-template #finished>\n          <button mat-fab color=\"accent\" (click)=\"done.next()\">\n            <mat-icon>done</mat-icon>\n          </button>\n        </ng-template>\n      </div>\n\n    </div>\n  </mat-sidenav-content>\n</mat-sidenav-container>\n",
                styles: [".navigation-buttons{margin:1rem;place-content:stretch space-between;-webkit-box-align:stretch;align-items:stretch;-webkit-box-orient:horizontal;-webkit-box-direction:normal;flex-direction:row;box-sizing:border-box;display:-webkit-box;display:flex}"]
            }] }
];
/** @nocollapse */
MatPagesComponent.ctorParameters = () => [
    { type: Renderer2 }
];
MatPagesComponent.propDecorators = {
    sidenav: [{ type: ViewChild, args: ['sidenav', { static: false },] }],
    tabHeader: [{ type: ViewChild, args: [MatTabGroup, { read: ElementRef, static: true },] }],
    pages: [{ type: ContentChildren, args: [MatPageLoaderComponent,] }],
    title: [{ type: Input }],
    done: [{ type: Output }],
    pageChanged: [{ type: Output }],
    onResize: [{ type: HostListener, args: ['window:resize', ['$event'],] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MatPagesModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: MatPagesModule,
            providers: []
        };
    }
}
MatPagesModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatToolbarModule,
                    MatTabsModule,
                    MatCardModule,
                    MatSidenavModule,
                    MatIconModule,
                    MatStepperModule,
                    MatButtonModule
                ],
                exports: [
                    MatPagesComponent,
                    MatPageLoaderComponent,
                    MatPageOutlookComponent,
                    MatPageContentComponent
                ],
                declarations: [
                    MatPagesComponent,
                    MatPageLoaderComponent,
                    MatPageOutlookComponent,
                    MatPageContentComponent
                ]
            },] }
];

export { MatPageContentComponent, MatPageLoaderComponent, MatPageOutlookComponent, MatPagesComponent, MatPagesModule };
//# sourceMappingURL=angular-material-extensions-pages.js.map
